/*
 # ---------------------------------------------------------------------
 #
 # Copyright (c) CREATIS (Centre de Recherche en Acquisition et Traitement de l'Image
 #                        pour la SantÈ)
 # Authors : Eduardo Davila, Frederic Cervenansky, Claire Mouton
 # Previous Authors : Laurent Guigues, Jean-Pierre Roux
 # CreaTools website : www.creatis.insa-lyon.fr/site/fr/creatools_accueil
 #
 #  This software is governed by the CeCILL-B license under French law and
 #  abiding by the rules of distribution of free software. You can  use,
 #  modify and/ or redistribute the software under the terms of the CeCILL-B
 #  license as circulated by CEA, CNRS and INRIA at the following URL
 #  http://www.cecill.info/licences/Licence_CeCILL-B_V1-en.html
 #  or in the file LICENSE.txt.
 #
 #  As a counterpart to the access to the source code and  rights to copy,
 #  modify and redistribute granted by the license, users are provided only
 #  with a limited warranty  and the software's author,  the holder of the
 #  economic rights,  and the successive licensors  have only  limited
 #  liability.
 #
 #  The fact that you are presently reading this means that you have had
 #  knowledge of the CeCILL-B license and that you accept its terms.
 # ------------------------------------------------------------------------ */


/*=========================================================================
  Program:   bbtk
  Module:    $RCSfile: bbtkWxBlackBox.h,v $
  Language:  C++
  Date:      $Date: 2012/11/16 08:49:01 $
  Version:   $Revision: 1.33 $
========================================================================*/



/**
 * \brief Short description in one line
 * 
 * Long description which 
 * can span multiple lines
 */
/**
 * \file 
 * \brief 
 */
/**
 * \class bbtk::
 * \brief 
 */


#ifdef USE_WT



#ifndef __bbtkWtBlackBox_h__
#define __bbtkWtBlackBox_h__



#include "bbtkWidgetBlackBox.h"
#include "bbtkWt.h"


namespace bbtk
{

 

  //==================================================================
  /// Widget black boxes
//EED 10/06/2009 /*BBTK_EXPORT*/
  class BBTK_EXPORT WtBlackBox : public bbtk::WidgetBlackBox<Wt::WContainerWidget>
  { 
  
 

  
  
  
  public:
    BBTK_BLACK_BOX_INTERFACE(WtBlackBox,bbtk::WidgetBlackBox<Wt::WContainerWidget>);
    
 	  
    //  protected:
    
  public:
  
     struct wtServerData
	   {
	      /*std::string docRoot;
	      std::string port;
	      std::string address;
	    */
	      static std::string docRoot  ;
	      static std::string port     ;
	      static std::string address  ;
	      
              static int argc;
              static char **argv;
	    };
  
  /*	static std::string* jScript;
    static void changeJScript(std::string newJScript){jScript=newJScript;};
    static std::string getJScript(){return jScript;};*/
   //==================================================================    
    /// Callback for creating a Dialog window (modal)
    /// ** Must be defined ** in toolkit specific descendants 
    virtual void bbCreateDialogWindow();
    //==================================================================    

    //==================================================================    
    /// Callback for creating a Frame window 
    /// ** Must be defined ** in toolkit specific descendants 
    virtual void bbCreateFrameWindow();
    //==================================================================    
    //staticwtServerData serData;
   // static void setServerInformation(std::string nDocRoot, std::string nPort, std::string nAddress);
    //==================================================================    
    Wt::WContainerWidget* bbGetWindow() { return bbmWindow; }
    void bbSetWindow(Wt::WContainerWidget*) ;
    bool bbWindowIsCreated() { return (bbGetWindow() != 0); }
   // Wt::WApplication *createApplication(const Wt::WEnvironment& env);
    //==================================================================    


    //==================================================================    
    virtual void bbShowWindow();
    //==================================================================   
 
    //==================================================================    
    virtual void bbDestroyWindow();
    //==================================================================    

   void bbwtUpdateInputs();
   void bbwtProcess();

  private:
    
    Wt::WApplication* bbApp;
    Wt::WContainerWidget* bbmWindow;
 
  };
  //=================================================================
 

  //=================================================================
  // WxBlackBoxDescriptor declaration
  class WtBlackBoxDescriptor : public WidgetBlackBoxDescriptor<Wt::WContainerWidget>
  BBTK_BEGIN_DESCRIBE_BLACK_BOX_BODY(WtBlackBox);
  BBTK_NAME("WtBlackBox");
  BBTK_END_DESCRIBE_BLACK_BOX(WtBlackBox);
  //=================================================================


} //namespace bbtk

#endif  //__bbtkWxBlackBox_h__

#endif  //USE_WXWIDGETS
