/*
 # ---------------------------------------------------------------------
 #
 # Copyright (c) CREATIS (Centre de Recherche en Acquisition et Traitement de l'Image
 #                        pour la SantÈ)
 # Authors : Eduardo Davila, Frederic Cervenansky, Claire Mouton
 # Previous Authors : Laurent Guigues, Jean-Pierre Roux
 # CreaTools website : www.creatis.insa-lyon.fr/site/fr/creatools_accueil
 #
 #  This software is governed by the CeCILL-B license under French law and
 #  abiding by the rules of distribution of free software. You can  use,
 #  modify and/ or redistribute the software under the terms of the CeCILL-B
 #  license as circulated by CEA, CNRS and INRIA at the following URL
 #  http://www.cecill.info/licences/Licence_CeCILL-B_V1-en.html
 #  or in the file LICENSE.txt.
 #
 #  As a counterpart to the access to the source code and  rights to copy,
 #  modify and redistribute granted by the license, users are provided only
 #  with a limited warranty  and the software's author,  the holder of the
 #  economic rights,  and the successive licensors  have only  limited
 #  liability.
 #
 #  The fact that you are presently reading this means that you have had
 #  knowledge of the CeCILL-B license and that you accept its terms.
 # ------------------------------------------------------------------------ */


//=====
// Before editing this file, make sure it's a file of your own (i.e.: it wasn't generated from xml description; if so : your modifications will be lost)
//===== 
#ifndef __bbstdVectorRescaleSlope_h_INCLUDED__
#define __bbstdVectorRescaleSlope_h_INCLUDED__
#include "bbstd_EXPORT.h"
#include "bbtkAtomicBlackBox.h"
#include "iostream"

namespace bbstd
{

class bbstd_EXPORT VectorRescaleSlope
 : 
   public bbtk::AtomicBlackBox
{
  BBTK_BLACK_BOX_INTERFACE(VectorRescaleSlope,bbtk::AtomicBlackBox);
//===== 
// Before editing this file, make sure it's a file of your own (i.e.: it wasn't generated from xml description; if so : your modifications will be lost)
//===== 
	BBTK_DECLARE_INPUT(In,std::vector<double>);
	BBTK_DECLARE_INPUT(Type,int);
	BBTK_DECLARE_INPUT(A,double);
	BBTK_DECLARE_INPUT(B,double);
	BBTK_DECLARE_OUTPUT(Out,std::vector<double>);
  BBTK_PROCESS(Process);
  void Process();
//===== 
// Before editing this file, make sure it's a file of your own (i.e.: it wasn't generated from xml description; if so : your modifications will be lost)
//===== 
};

BBTK_BEGIN_DESCRIBE_BLACK_BOX(VectorRescaleSlope,bbtk::AtomicBlackBox);
	BBTK_NAME("VectorRescaleSlope");
	BBTK_AUTHOR("Info-Dev");
	BBTK_DESCRIPTION("Rescale and slope of a vector");
	BBTK_CATEGORY("");
	
	BBTK_INPUT(VectorRescaleSlope,In,"Input vector",std::vector<double>,"");
	BBTK_INPUT(VectorRescaleSlope,Type,"type of operation: 0 (default) SlopeIntercept np=p*A+B, 1 Invert, 2 Redimension A=newMin B=newMax, 3 InvertRedimension A=newMin B=newMax",int,"");
	BBTK_INPUT(VectorRescaleSlope,A,"(1 default) see Type description",double,"");
	BBTK_INPUT(VectorRescaleSlope,B,"(0 default) see Type description",double,"");
	BBTK_OUTPUT(VectorRescaleSlope,Out,"Output vector",std::vector<double>,"");
BBTK_END_DESCRIBE_BLACK_BOX(VectorRescaleSlope);
//===== 
// Before editing this file, make sure it's a file of your own (i.e.: it wasn't generated from xml description; if so : your modifications will be lost)
//===== 
}
// EO namespace bbstd

#endif // __bbstdVectorRescaleSlope_h_INCLUDED__

